unit ExtraMapsOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls, SLR6;

type
  TExtraMapsForm = class(TForm)
    SalinityMapsBox: TCheckBox;
    DucksMapsBox: TCheckBox;
    Button1: TButton;
    AccretionMapsBox: TCheckBox;
    SAVMapsBox: TCheckBox;
    ConnectMapsBox: TCheckBox;
    SAVWarningLabel: TLabel;
    procedure ExtraMapsBoxClick(Sender: TObject);
    //procedure SAVMapsBoxClick(Sender: TObject);
    procedure UpdateScreen;
    //procedure SAVWarningLabelClick(Sender: TObject);
  private
    { Private declarations }
    Updating : boolean;
  public
    { Public declarations }
    ESS: TSLAMM_Simulation;
  end;

var
  ExtraMapsForm: TExtraMapsForm;



implementation

uses
Execute;

{$R *.dfm}

procedure TExtraMapsForm.ExtraMapsBoxClick(Sender: TObject);
begin
  if Updating then exit;

  ESS.SalinityMaps:= SalinityMapsBox.Checked;
  ESS.AccretionMaps:= AccretionMapsBox.Checked;
  ESS.DucksMaps := DucksMapsBox.Checked;
  ESS.SAVMaps := SAVMapsBox.Checked;
  ESS.ConnectMaps := ConnectMapsBox.Checked;

end;

procedure TExtraMapsForm.UpdateScreen;
begin
  Updating := True;

  SalinityMapsBox.Checked := ESS.SalinityMaps;
  SalinityMapsBox.Enabled := ESS.Display_Screen_Maps;
  If SalinityMapsBox.Checked and (not ExecuteOptionForm.SaveToGIF.Checked) then ExecuteOptionForm.AutoPasteMaps.Checked:= True;

  AccretionMapsBox.Checked := ESS.AccretionMaps;
  AccretionMapsBox.Enabled := ESS.Display_Screen_Maps;
  If AccretionMapsBox.Checked and (not ExecuteOptionForm.SaveToGIF.Checked) then ExecuteOptionForm.AutoPasteMaps.Checked:= True;

  DucksMapsBox.Checked := ESS.DucksMaps;
  DucksMapsBox.Enabled := ESS.Display_Screen_Maps;
  If DucksMapsBox.Checked and (not ExecuteOptionForm.SaveToGIF.Checked) then ExecuteOptionForm.AutoPasteMaps.Checked:= True;

  SAVWarningLabel.Visible := False;
  SAVMapsBox.Enabled := True;
  SAVMapsBox.Checked := ESS.SAVMaps;
  SAVMapsBox.Enabled := ESS.Display_Screen_Maps;
  if (Trim(ESS.D2MFileN)='') then
    begin
      SAVMapsBox.Enabled := False;
      SAVWarningLabel.Visible := True;
    end;
  If SAVMapsBox.Checked and (not ExecuteOptionForm.SaveToGIF.Checked) then ExecuteOptionForm.AutoPasteMaps.Checked:= True;

  ConnectMapsBox.Checked := ESS.ConnectMaps;
  ConnectMapsBox.Enabled := ESS.Display_Screen_Maps;
  If ConnectMapsBox.Checked and (not ExecuteOptionForm.SaveToGIF.Checked) then ExecuteOptionForm.AutoPasteMaps.Checked:= True;

  Updating := False;
end;

end.
