//SLAMM SOURCE CODE Copyright (c) 2009 Warren Pinnacle Consulting, Inc.
//Code Use and Redistribution is Subject to Licensing, SEE SLAMM_License.txt
//

program SLAMM6;

uses
  Forms,
  SysUtils,
  main in 'main.pas' {MainForm},
  DrawGrid in 'DrawGrid.pas' {GridForm},
  SLAMMLegend in 'SLAMMLegend.pas' {LegendForm},
  GISOptions in 'GISOptions.pas' {GISForm},
  batchnote in 'batchnote.pas' {OKBottomDlg},
  global in 'global.pas',
  Profile in 'Profile.pas' {ProfileForm},
  slr6 in 'slr6.pas',
  Execute in 'Execute.pas' {ExecuteOptionForm},
  GLDraw in 'GLDraw.pas' {Delphi3DForm},
  DispMode in 'OpenGL\Framework\DispMode.pas' {DotDispModeDlg},
  FileSetup in 'FileSetup.pas' {FileSetupForm},
  SalRuleEdit in 'SalRuleEdit.pas' {SalRuleForm},
  SiteEdits in 'SiteEdits.pas' {SiteEdit},
  Elev_Analysis in 'Elev_Analysis.pas' {ElevAnalysisForm},
  FFForm in 'FFForm.pas' {SalinityForm},
  ElevHistForm in 'ElevHistForm.pas' {Elevation Histograms},
  splash in 'splash.pas' {SplashForm},
  Utility in 'Utility.pas',
  Windows,
  UncertMain in 'UncertMain.pas' {UncertForm},
  uncertdefn in 'uncertdefn.pas' {,},
  SensitivityRun in 'SensitivityRun.pas',
  distedit in 'distedit.pas' {DistributionForm},
  selectinput in 'selectinput.pas' {SelInput},
  Uncert in 'Uncert.pas',
  LatinHypercubeRun in 'LatinHypercubeRun.pas',
  legend2 in 'legend2.pas' {LegendForm2},
  copyclip in 'copyclip.pas' {CopyClipbd},
  progress in 'progress.pas' {ProgForm},
  stack in 'stack.pas',
  Vcl.Themes,
  Vcl.Styles,
  Infrastructure in 'Infrastructure.pas' {InfStructFileSetup},
  SalArray in 'SalArray.pas',
  ExtraMapsOptions in 'ExtraMapsOptions.pas' {ExtraMapsForm},
  SAVParams in 'SAVParams.pas' {SAVParamForm},
  FWFlowEdits in 'FWFlowEdits.pas' {FWFlowEdit};

{$R *.RES}
{$SetPEFlags IMAGE_FILE_LARGE_ADDRESS_AWARE}           // Enable 4 gigabytes of memory
Var Timecheck: TDatetime;

// {$.define FullDebugMode}
// {$.define RawStackTraces}

begin
//  ReportMemoryLeaksOnShutdown := DebugHook <> 0;  {report mem leaks}
  Application.Initialize;
  Application.Title := 'SLAMM 6.3 beta';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TSplashForm, SplashForm);
  Application.CreateForm(TSelInput, SelInput);
  Application.CreateForm(TElevHist, ElevHist);
  Application.CreateForm(TCopyClipbd, CopyClipbd);
  Application.CreateForm(TProgForm, ProgForm);
  Application.CreateForm(TInfStructFileSetup, InfStructFileSetup);
  Application.CreateForm(TExtraMapsForm, ExtraMapsForm);
  Application.CreateForm(TExtraMapsForm, ExtraMapsForm);
  Application.CreateForm(TSAVParamForm, SAVParamForm);
  Application.CreateForm(TFWFlowEdit, FWFlowEdit);
  SplashForm.VersionInfo.Visible := False;
  SplashForm.Show;
  SplashForm.Update;
  TimeCheck:=Now;

  Application.CreateForm(TFileSetupForm, FileSetupForm);
  Application.CreateForm(TFWFlowEdit, FWFlowEdit);
  Application.CreateForm(TSalRuleForm, SalRuleForm);
  Application.CreateForm(TSalinityForm, SalinityForm);
  Try
    Application.CreateForm(TDotDispModeDlg, DotDispModeDlg);
  Except
    Raise;
  End;

  Application.CreateForm(TElevAnalysisForm, ElevAnalysisForm);
  Application.CreateForm(TGridForm, GridForm);
  Application.CreateForm(TFileSetupForm, FileSetupForm);
  Application.CreateForm(TSiteEditForm, SiteEditForm);
  Application.CreateForm(TLegendForm, LegendForm);
  Application.CreateForm(TLegendForm2, LegendForm2);
  Application.CreateForm(TGISForm, GISForm);
  Application.CreateForm(TOKBottomDlg, OKBottomDlg);
  Application.CreateForm(TProfileForm, ProfileForm);
  Application.CreateForm(TFWFlowEdit, FWFlowEdit);
  Application.CreateForm(TSalinityForm, SalinityForm);
  Application.CreateForm(TExecuteOptionForm, ExecuteOptionForm);
  Application.CreateForm(TUncertForm, UncertForm);
  Application.CreateForm(TDistributionForm, DistributionForm);
  Application.CreateForm(TSelInput, SelInput);

  Repeat Until Now-TimeCheck>2.8e-5; {Hold splash form for a minimum of 2 seconds}
  SplashForm.Hide;

  Application.Run;

  end.


